<template>
  <form id="loginForm" v-show="notSignedIn">
    <h2>Login</h2>
    <input type="text" id="email" v-model="email" placeholder="Email" required />
    <input type="password" id="password" v-model="password" placeholder="Password" required />
    <input type="submit" value="Login" @click.prevent="signIn" />
  </form>
  <p>{{ message }}</p>
</template>
<script setup>
import { onMounted, reactive, ref } from 'vue'
import { useAuthStore } from '../stores/auth';

const credentials = reactive({
  email: '',
  password: ''
})

const email = ref('');
const password = ref('');

const authStore = useAuthStore();

const message = ref('')

const notSignedIn = ref(true)

async function signIn() {
  try {
    const fetchResult = await fetch('https://testpage/login', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({ credentials: {email, password} })
    })
    const json = await fetchResult.json()
    if (json.message === 'Success') {
      message.value = 'Signed in successfully';
      localStorage.setItem('authenticated', true);
      authStore.setUser(email);

    }
    if (json.message === 'Failure') message.value = 'Incorrect credentials'

  } catch {
    message.value = 'Incorrect credentials'
  }
}

onMounted(() => {
  message.value = localStorage.getItem('authenticated') ? 'Signed in successfully' : 'Incorrect credentials';
})
</script>
<style scoped>
/* Add some basic styles to center the form */
body {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh;
  margin: 0;
  font-family: Arial, sans-serif;
}

form {
  width: 300px;
  padding: 20px;
  border: 1px solid #ccc;
  border-radius: 5px;
  background-color: #f5f5f5;
}

input[type='text'],
input[type='password'] {
  width: 100%;
  padding: 10px;
  margin-bottom: 10px;
  box-sizing: border-box;
}

input[type='submit'] {
  width: 100%;
  padding: 10px;
  border: none;
  background-color: #4caf50;
  color: #fff;
  cursor: pointer;
}
</style>
